Index: /trunk/SophyaPI/PI/pintup3d.cc
===================================================================
--- /trunk/SophyaPI/PI/pintup3d.cc	(revision 132)
+++ /trunk/SophyaPI/PI/pintup3d.cc	(revision 133)
@@ -19,5 +19,5 @@
 
 /* --Methode-- */
-void  PINTuple3D::SelectXYZ(char* px, char* py, char* pz)
+void  PINTuple3D::SelectXYZ(const char* px, const char* py, const char* pz)
 {
 if (mNT == NULL)  xK = yK = zK = -1;
@@ -31,5 +31,5 @@
 
 /* --Methode-- */
-void  PINTuple3D::SelectErrBar(char* erbx, char* erby, char* erbz)
+void  PINTuple3D::SelectErrBar(const char* erbx, const char* erby, const char* erbz)
 {
 if (mNT == NULL)  xebK = yebK = zebK = -1;
Index: /trunk/SophyaPI/PI/pintup3d.h
===================================================================
--- /trunk/SophyaPI/PI/pintup3d.h	(revision 132)
+++ /trunk/SophyaPI/PI/pintup3d.h	(revision 133)
@@ -13,6 +13,6 @@
   virtual void       UpdateLimits();
   
-          void       SelectXYZ(char* px, char* py, char* pz);
-          void       SelectErrBar(char* erbx=NULL, char* erby=NULL, char* erbz=NULL);
+          void       SelectXYZ(const char* px, const char* py, const char* pz);
+          void       SelectErrBar(const char* erbx=NULL, const char* erby=NULL, const char* erbz=NULL);
 
        
Index: /trunk/SophyaPI/PI/pintuple.cc
===================================================================
--- /trunk/SophyaPI/PI/pintuple.cc	(revision 132)
+++ /trunk/SophyaPI/PI/pintuple.cc	(revision 133)
@@ -19,5 +19,5 @@
 
 /* --Methode-- */
-void  PINTuple::SelectXY(char* px, char* py)
+void  PINTuple::SelectXY(const char* px, const char* py)
 {
 if (mNT == NULL)  xK = yK = -1;
@@ -29,5 +29,5 @@
 
 /* --Methode-- */
-void  PINTuple::SelectErrBar(char* erbx, char* erby)
+void  PINTuple::SelectErrBar(const char* erbx, const char* erby)
 {
 if (mNT == NULL)  xebK = yebK = -1;
Index: /trunk/SophyaPI/PI/pintuple.h
===================================================================
--- /trunk/SophyaPI/PI/pintuple.h	(revision 132)
+++ /trunk/SophyaPI/PI/pintuple.h	(revision 133)
@@ -13,6 +13,6 @@
   virtual void       UpdateLimits();
   
-          void       SelectXY(char* px, char* py);
-          void       SelectErrBar(char* erbx=NULL, char* erby=NULL);
+          void       SelectXY(const char* px, const char* py);
+          void       SelectErrBar(const char* erbx=NULL, const char* erby=NULL);
 
        
Index: /trunk/SophyaPI/PI/pistzwin.cc
===================================================================
--- /trunk/SophyaPI/PI/pistzwin.cc	(revision 132)
+++ /trunk/SophyaPI/PI/pistzwin.cc	(revision 133)
@@ -7,10 +7,18 @@
 #include "psfile.h"
 
+// Fonction de l'objet PIPeriodic de PIStackWindow
+static void myadperpact(void* a);
+
+void myadperpact(void* a)
+{
+((PIStackWindow*)a)->DispNext();
+}
 /* --Methode-- */
 PIStackWindow::PIStackWindow(PIMsgHandler* par, char* nom, PIWindowKind k,
                              int sx, int sy, int px, int py)
-        : PIWindow(par, nom, k, sx, sy, px, py)
+        : PIWindow(par, nom, k, sx, sy, px, py) , mPerad(1)
 {
-curdisp = -1;
+mCurdisp = -1;
+mPerad.SetAction(myadperpact, this);
 } 
 
@@ -19,4 +27,6 @@
 PIStackWindow::~PIStackWindow()
 {
+mPerad.Stop();
+Hide();
 }
 
@@ -28,5 +38,5 @@
 PIWindow::ChildAdd(child);
 child->Manage();
-curdisp = NbChilds()-1;
+mCurdisp = NbChilds()-1;
 return;
 }
@@ -39,10 +49,10 @@
 PIWindow::ChildDel(child);
 if (NbChilds() > 0) {
-  curdisp--;
-  if (curdisp < 0)  curdisp = 0;
-  if (curdisp > NbChilds()) curdisp = NbChilds()-1; 
-  GetChild(curdisp)->Manage();
+  mCurdisp--;
+  if (mCurdisp < 0)  mCurdisp = 0;
+  if (mCurdisp > NbChilds()) mCurdisp = NbChilds()-1; 
+  GetChild(mCurdisp)->Manage();
   }
-else curdisp = -1;
+else mCurdisp = -1;
 return;
 }
@@ -65,8 +75,22 @@
 int k;
 for(k=0; k<NbChilds(); k++) GetChild(k)->UnManage();
-curdisp = (curdisp+1)%NbChilds();
-GetChild(curdisp)->Manage();
+mCurdisp = (mCurdisp+1)%NbChilds();
+GetChild(mCurdisp)->Manage();
 return;
 }
+
+/* --Methode-- */
+void PIStackWindow::StartAutoDisp(int dt)
+{
+mPerad.Start(dt);
+}
+
+/* --Methode-- */
+void PIStackWindow::StopAutoDisp()
+{
+mPerad.Stop();
+}
+
+//-------------------------------------------------------------------------------
 
 /* --Methode-- */
Index: /trunk/SophyaPI/PI/pistzwin.h
===================================================================
--- /trunk/SophyaPI/PI/pistzwin.h	(revision 132)
+++ /trunk/SophyaPI/PI/pistzwin.h	(revision 133)
@@ -8,4 +8,5 @@
 #include "pisysdep.h"
 #include PIWIN_H
+#include PIPERIODIC_H
 
 // ----------------------- Classe PIStackWindow ----------------------------
@@ -25,7 +26,10 @@
 
   virtual void  DispNext();
+  virtual void  StartAutoDisp(int dt);
+  virtual void  StopAutoDisp();
 
 protected:
-  int curdisp;
+  PIPeriodic mPerad;
+  int mCurdisp;
 };
 